
public class Card {
	
	public final static int SUITS=4, NUMCARDS=8;
	public final static int CLUBS=0,
							DIAMNONDS=1,
							HEARTS=2,
							SPADES=3;
	public final static String[] SUITSTRINGS= {	"Clubs",
												"Diamonds",
												"Hearts",
												"Spades"};
	public final static String[] CARDSTRINGS= {	"Jack",
												"Queen",
												"King",
												"Ace",
												"7",
												"8",
												"9",
												"10",};
	

	protected String owner;
	protected int suit, value;
	
	
	public Card(int suit, int value)
	{
		this.suit=suit;
		this.value=value;
		
		//modern..
	}
	
	public Card(int suit, int value, String owner)
	{
		this(suit,value);
		this.owner=owner;
	}
	
	public boolean equals(Card card)
	{
		if ((this.suit == card.suit) && (this.value == card.value))
			return true;
		else
			return false;
	}
	
	
	public String getOwner()
	{
		return owner;
	}
	
	public int getSuit()
	{
		return suit;
	}
	
	public int getValue()
	{
		return value;
	}
	
	public String getDescription()
	{
		//return "Card: suit:"+getSuit()+" value:"+getValue();
		return "Card: "+CARDSTRINGS[getValue()]+" of "+SUITSTRINGS[getSuit()]; 
	}
	
	public void setOwner(String owner)
	{
		if (this.owner.equals(owner))
			System.err.println("This card is already in the possession of "+owner);
		this.owner = owner;
	}
	
}
