import java.util.*;

public class Deck {
	
	protected Card[] cards = new Card[Card.SUITS*Card.NUMCARDS];
	int curnumcards;
	
	public Deck()
	{
		reset();
	}
	
	public void reset()
	{
		//		 Fill the deck.
		for (int i=0; i<Card.SUITS; i++)
			for (int j=0; j<Card.NUMCARDS; j++)
				cards[(i*Card.NUMCARDS)+j] = new Card(i,j,"Deck");

		curnumcards = Card.SUITS*Card.NUMCARDS;
		
		shuffle();
	}
	
	//	 Shuffle the deck.
	public void shuffle()
	{
		// Shuffle n-times for n cards. This should be plenty.
		Card tempcard;
		for (int i=0; i<curnumcards*3; i++)
		{
			int index1 = Game.generator.nextInt(curnumcards);
			int index2 = Game.generator.nextInt(curnumcards);
			tempcard = cards[index1];
			cards[index1]=cards[index2];
			cards[index2]=tempcard;
		}
	}
	
	public void dumpCards()
	{
		for (int i=curnumcards-1; i>=0; i--)
			System.out.println(cards[i].getDescription());
	}
	
	public Card drawCard(String newOwner)
	{
		Card card = cards[curnumcards-1];
		curnumcards--;
		card.setOwner(newOwner);
		return card;
	}
	
}
