import java.util.Vector;

public class GreedyPlayer extends Player{

	boolean output=false;
	boolean[][] playerOutOfSuit = new boolean[Game.numplayers][4];
	
	public GreedyPlayer(String name)
	{
		super(name);
		reset();
	}
	
	public void reset()
	{
		super.reset();
		for (int i=0; i<Game.numplayers; i++)
			for (int j=0; j<4; j++)
				playerOutOfSuit[i][j]=false;
	}
	
	// TODO - darn, this is harder than it seems.
	public void updatePlayerOutOfSuit(Card[] totalgame, int currindex, int round, int roundplayer)
	{
		// TODO: It is not very efficient to process the whole game every time.
		
	}
	
	// Compute the possibility that a card can regain the initiative.
	public double computeCardRegainPossibility(Card[] totalgame, int currindex, int round, int roundplayer, Card card)
	{	
		//		 Make a vector of cards that can be beaten with this card.
		Vector canRegainThisCard = new Vector(card.getValue());
		for (int i=0; i<card.getValue(); i++)
			canRegainThisCard.add(new Card(card.getSuit(),i));
		
		// See if any are already played, and if so, remove them from the vector.
		for (int i=0; i<currindex; i++)
			for (int j=0; j<canRegainThisCard.size(); j++)
				if (totalgame[i].equals((Card) canRegainThisCard.get(j)))
					canRegainThisCard.remove(j);
		
		// See if i own any of these, and if so, remove them from the vector
		for (int i=0; i<curnumcards; i++)
			for (int j=0; j<canRegainThisCard.size(); j++)
				if (((Card) cards.get(i)).equals((Card) canRegainThisCard.get(j)))
					canRegainThisCard.remove(j);
		
		if (output)
		{
			System.out.println("Kaart "+card.getDescription()+" kan nog verslaan:");
			for (int i=0; i<canRegainThisCard.size(); i++)
				System.out.println("	"+((Card) canRegainThisCard.get(i)).getDescription());
		}
		
		double notRegainPossibility = 1;
		double totalcards = Card.SUITS * Card.NUMCARDS;
		double pSpecificCard = 1 / totalcards;
		double pSpecificSuit = 1. / 4.;
		// For all the cards that i can beat with this card, compute the individual
		// probability that they come out on top, and calculate the total probability that one of them occurs.
		for (int j=0; j<canRegainThisCard.size(); j++)
		{
			Card specificCard = (Card) canRegainThisCard.get(j);
			// If we KNOW that we have the right suit, we should use this.
			/*if (specificCard.suit == currentSuit)
				pSpecificSuit = 1;*/
			
			double pCardBeatPossibility = computeCardBeatPossibility(totalgame,currindex,round,roundplayer,specificCard);
			double pCardEmergesWinning = pSpecificCard * pSpecificSuit * (1-pCardBeatPossibility);
			notRegainPossibility *= (1-pCardEmergesWinning);
		}
		
		return (1-notRegainPossibility);
	}
	
	// compute the possibility that the card can be beaten in this round, if we can still win.
	public double computeCardBeatPossibility(Card[] totalgame, int currindex, int round, int roundplayer, Card card)
	{
		//if (card.getSuit() != suit)
		//	return 1.;
		//else
		{
			// Make a vector of cards that can beat this card.
			Vector canBeatThisCard = new Vector(Card.NUMCARDS - card.getValue());
			for (int i=card.getValue(); i<Card.NUMCARDS; i++)
				canBeatThisCard.add(new Card(card.getSuit(),i));
			
			// See if any are already played, and if so, remove them from the vector.
			for (int i=0; i<currindex; i++)
				for (int j=0; j<canBeatThisCard.size(); j++)
					if (totalgame[i].equals((Card) canBeatThisCard.get(j)))
						canBeatThisCard.remove(j);
			
			// See if i own any of these, and if so, remove them from the vector
			for (int i=0; i<curnumcards; i++)
				for (int j=0; j<canBeatThisCard.size(); j++)
					if (((Card) cards.get(i)).equals((Card) canBeatThisCard.get(j)))
						canBeatThisCard.remove(j);	
			
			if (output)
			{
			//	System.out.println("Kaart "+card.getDescription()+" kan nog verslagen worden met:");
			//	for (int i=0; i<canBeatThisCard.size(); i++)
			//		System.out.println("	"+((Card) canBeatThisCard.get(i)).getDescription());
			}
			
			// Argh, I should be able to do possbibility calculations.
			double totalcards = Card.SUITS * Card.NUMCARDS;
			double beatcards = canBeatThisCard.size();
			double beatchancePerCard = beatcards / totalcards;
			
			double cardsinhands = (Game.numplayers*4) - ((round * Game.numplayers) + roundplayer);
			double cardsInHandPerPlayer = cardsinhands/4;
			double playersleft = 4-(roundplayer+1);
			
			double notbeatchancepercard = (1-beatchancePerCard);
			double notbeatchanceperplayer = Math.pow(notbeatchancepercard,cardsInHandPerPlayer);
			double beatpossibility = 1-(Math.pow(notbeatchanceperplayer,playersleft));
			
			// Every card has a possibility of beatcards / totalcards to be a card that can beat this card.
			//double beatpossibility = (beatcards/totalcards) * (cardsInHandPerPlayer*playersleft);
			//if (output) System.out.println("("+beatcards+"/"+totalcards+") * ("+cardsInHandPerPlayer+"*"+playersleft+") ="+beatpossibility);
			return beatpossibility;
		}
	}
	
	/*public Card getOptimalCard(Card[] totalgame, Card[] mycards, int currindex, int round, int roundplayer)
	{
		// Compute which cards can beat our cards. 
		// Compute which of those cards are still in the game.
		// Compute the chance that one of our opponents possesses that card.
		
		return null;
	}*/
	public Card computeLowestRegainChance(Card[] totalgame, int currindex, int round, int roundplayer, Vector cards)
	{
		double regainchance = 2;
		int regainindex=-1;
		for (int j=0; j<cards.size(); j++)
		{
			double currRegainChance = computeCardRegainPossibility(totalgame,currindex,round+1,0,(Card) cards.get(j));
			if ( currRegainChance < regainchance)
			{
				regainchance = currRegainChance;
				regainindex = j;	
			}
			
			if (output)
				System.out.println("   RegainChance: "+((Card) cards.get(j)).getDescription()+" "+currRegainChance);
		}
		
		return (Card) cards.get(regainindex);
	}
	
	public Card drawCard(String newOwner,  Card[] totalgame, int currindex, int round, int roundplayer)
	{
		if (output)
		{
			System.out.println("	"+name+":: Ik heb nog:  in round"+round);
			for (int i=0; i<cards.size(); i++)
				System.out.println("	"+((Card) cards.get(i)).getDescription());
		}
		
		int suit = whichSuit(totalgame,currindex,round,roundplayer);
		Vector possibleCards = possibleCards(suit);
		Vector possibleWincards=possibleWinCards(suit);
		Card card;// = new Card(0,0);
		
		if (possibleWincards.size() == 0)
		{
			if (possibleCards.size() == 0)
				//card = getLowestCard(cards);
				card = computeLowestRegainChance(totalgame,currindex,round,roundplayer,cards);
			else
				//card = getLowestCard(possibleCards); // We have to play the right suit, if we have it.
				card = computeLowestRegainChance(totalgame,currindex,round,roundplayer,possibleCards);
		}
		else
		{
			//			 Compute for every card, the chance that it is beaten.
			int lowestBeatChanceIndex = -1;
			double lowestBeatChance = 100;
			
			for (int j=0; j<possibleWincards.size(); j++)
			{
				double beatChance = computeCardBeatPossibility(totalgame,currindex,round,roundplayer,(Card) possibleWincards.get(j));
				if ( beatChance < lowestBeatChance)
				{
						lowestBeatChance = beatChance;
						lowestBeatChanceIndex = j;
				}
				if (output)
				{
					System.out.println("   BeatChance "+((Card) possibleWincards.get(j)).getDescription()+" "+beatChance);
				}
			}
			// TODO: Tweaking. - Throw away the most useless card in round 1, or if the chance of winning is too low.
			if ((lowestBeatChance > 0.5) || (round < 2)) 
				card = (Card) computeLowestRegainChance(totalgame,currindex,round,roundplayer,possibleWincards);
			else
				card = (Card) possibleWincards.get(lowestBeatChanceIndex);
		}
		
		
		
		// Compute the chance that a round is beaten for every possible card.
		
		// Play the card with the lowest probability of losing the round.
		
		curnumcards--;
		card.setOwner(newOwner);
		cards.remove(cards.indexOf(card));
		playedCards.add(card);
		return card;
	}
}
