import java.applet.*; 
import java.awt.*; 
import java.net.*; 
import java.awt.image.*;
import java.awt.event.*;

public class Main extends Applet implements ActionListener, AdjustmentListener  {
	BufferedImage playingCards;	
	
	//Imagelocations in the image.. J,Q,K,A,7,8,9,10
	int[] imageLocations = {5,6,7,0,1,2,3,4};
	
	//the card selected
	int selectedCard = -1;
	int playerCardCount = 4;
	
	Button b1, b2;
	Scrollbar s1;
	TextArea ta1;
	
	Game g1;
	
	public Main()
	{
		//resize(500, 500);
		setLayout(null);
		
		//initialize the game..
		b1 = new Button("Start Game");
		b1.setBounds(10, 10, 100, 20);
		add(b1);
		b1.addActionListener(this);
		
		b2 = new Button("Pauze Game");
		b2.setBounds(10, 35, 100, 20);
		add(b2);
		b2.addActionListener(this);
		b2.setEnabled(false);

		Label l1 = new Label("Delay");
		l1.setBackground(Color.LIGHT_GRAY);
		l1.setBounds(10,60,100,20);		
		add(l1);
		
		s1 = new Scrollbar(Scrollbar.HORIZONTAL);
		s1.setMaximum(5000);
		s1.setMinimum(50);
		s1.setValue(2000);		
		s1.setBounds(10,80,100,20);
		s1.addAdjustmentListener(this);
		add(s1);
				
		ta1 = new TextArea();
		ta1.setBounds(740, 0, 260, 600);
		//ta1.enable(false);		
		add(ta1);
		
		setVisible(true);				
	}
	
	public void gameEnded()
	{		
		b1.setLabel("Start game");	
		b1.setEnabled(true);
		b2.enable(false);
		g1 = null;
	}
	
	public void adjustmentValueChanged(AdjustmentEvent e)
	{
		if(e.getSource() == s1)
		{
			if(g1 != null)
				g1.setDelay(s1.getValue());
		}
	}
	 
	
	public void init()  
	{
		//ta1.setText(getDocumentBase().toString());
		//get the image loader
		MediaTracker mt; 
		mt = new MediaTracker(this); 
		URL base = null;				

		try 
		{ 
		  // getDocumentbase gets the applet path. 
               base = getDocumentBase(); 
		} 
        catch (Exception e) {} 

        Image my_gif = getImage(base,"Toepen2.jpg"); 
        
        mt.addImage(my_gif,1); 

        // now tell the mediaTracker to stop the applet execution 
        // (in this example don't paint) until the images are fully loaded. 
        // must be in a try catch block. 

        try { 
             mt.waitForAll(); 
        } 
        catch (InterruptedException  e) {} 
  
        playingCards = new BufferedImage(500, 364,BufferedImage.TYPE_INT_RGB);
        Graphics2D g2 = (Graphics2D)playingCards.getGraphics();
        playingCards.getGraphics().drawImage(my_gif, 0, 0, 500, 364, this);
        
		//ImageLoader imageLoader1 = new ImageLoader();
		//playingCards = imageLoader1.getImageBuffered("D:/Jelle/Toepen/Toepen/bin/" + "",500,364);	
		
	}
	
	public void writeToConsole(String text)
	{
		ta1.setText(ta1.getText() + text + "\n");
		
		ta1.setCaretPosition(ta1.getText().length() - (text.length()));
	}
	
	public void actionPerformed(ActionEvent e) {
		  if(e.getSource() == b1)
		  {
			  if(g1 == null)
			  {
				  g1 = new Game(this);			
				  g1.setDelay(s1.getValue());
				  g1.start();
				  ta1.setText("");
				  
			  }
			  else
			  {
				g1.resume();  
				  
			  }
			  b1.setEnabled(false);
			  b2.setEnabled(true);
		  }
		  if(e.getSource() == b2)
		  {			  
			  System.out.println("Thread yielded...");
			  g1.suspend();		  
			  b1.setEnabled(true);
			  b2.setEnabled(false);
			  b1.setLabel("Resume game");
		  }
    }
	
	protected void handleMouseClicked(MouseEvent e)
	{
		int x = e.getX();
		int y = e.getY();
		
		selectedCard = getCardSelected(x,y);
		if(selectedCard != -1) b1.setEnabled(true);
		else b1.setEnabled(false);
		
		repaint();
	}
	
	//gets the selected card (0,1,2,3) or -1
	protected int getCardSelected(int x, int y)
	{
		int rt =-1;
		int xThreshold = 40 * (4 - playerCardCount);
		
		if((x >= 260 && x <= 442 - xThreshold) && (y >= 470 && y <= (99+470)))
		{
			if((playerCardCount == 4) &&  x >= (442 - 63) && y >= 479) rt = 3;
			else if((playerCardCount >=3) && x >= (442 - (63 + 40)) && x <= (442 - 40) && y >= 476 && y <= (96 + 470)) rt = 2;
			else if((playerCardCount >=2) && x >= (442 - (63 + 80)) && x <= (442 - 80) && y >= 473 && y <= (93 + 470)) rt = 1;
			else if(y <= (90 + 470) && x <= (442 - 120)) rt = 0;		
		}
		if(rt > (playerCardCount - 1)) rt = -1;
		
		return rt;		
	}
	
	//gets the requested card from the playingCards
	// suite = {0,1,2,3}
	// number = {0,1,2,3,4,5,6,7}
	protected BufferedImage getCard(int suite, int number)
	{		
		number = imageLocations[number];
		
		BufferedImage rt = null;
		int y = 0;
		int x = (62 * number);
		
		//some little fixes
		if(number > 2) x++;
		if(number > 4) x++;
		if(number > 6) x++;
		
		//switch the suite..
		switch(suite)
		{
			case 1:
				y = 91;
			break;
			case 2:
				y = 181;
			break;
			case 3:
				y = 272;
			break;
		}
		
		
		// check if the playingCards are defined
		if(playingCards != null)
		{
			//cards are 62x91		
			rt = playingCards.getSubimage(x, y, 63, 91);
		}
		
		return rt;
	}

	public void update(Graphics g)
	{
		paint(g);
	}
		
	public void paintCardsInHand(Graphics2D g2, Player p1)
	{
		g2.setColor(Color.LIGHT_GRAY);
		g2.fillRect(0, 0, 204, 322);
		
		g2.setColor(Color.GREEN);
		g2.fillRect(1, 200, 201, 320 - 200);
		g2.setColor(Color.BLACK);
		g2.drawRect(1, 200, 201, 320 - 200);
		
		//g2.setColor(Color.RED);
		//if((x >= 260 && x <= (442 - 260)) && (y >= 470 && y <= 470 + 99))
		//g2.drawRect(260, 470, 442 - 260, 99);
		int windowX = 10;
		int windowY = 16 + 200;

		g2.drawString(p1.getName(), 60 ,12 + 200);
		
		for(int i =0; i < p1.getCards().size(); i ++)
		{
				Card c1 = (Card)(p1.getCards().elementAt(i));
				
				BufferedImage bi = getCard(c1.getSuit(),c1.getValue());
				
				int x1 = windowX + (i * 40);
				int y1 = windowY + (i * 3);
				
				g2.drawImage(bi,x1 ,y1 , this);											
		}
		
		windowX = 15;
		windowY = 90;
		
		for(int i =0; i < p1.getPlayerCards().size(); i++)
		{
			Card c1 = (Card)(p1.getPlayerCards().elementAt(i));
			BufferedImage bi = getCard(c1.getSuit(),c1.getValue());
			int x1 = windowX + (i * 40);
			int y1 = windowY + (i * 3);

			g2.drawImage(bi,x1 ,y1 , this);	
		}
	}
	
	public void paint(Graphics g)
	{
		BufferedImage contentImage = new BufferedImage(getWidth(), getHeight(),BufferedImage.TYPE_INT_RGB);
		Graphics2D g2 = (Graphics2D)contentImage.getGraphics();
		
		g2.setColor(Color.LIGHT_GRAY);
		g2.fillRect(0, 0, this.getWidth(), this.getHeight());		
		
		if(g1 != null)
		{
			//player 1
			BufferedImage bi1 = new BufferedImage(321, 203,BufferedImage.TYPE_INT_RGB);
			Graphics2D g3 = (Graphics2D)bi1.getGraphics();
			g3.translate(321, 0);
			g3.rotate(Math.PI / 2);		
			paintCardsInHand(g3,g1.getPlayers()[3]);		
			g2.drawImage(bi1, 10, 150, this);
	
			//player 2
			bi1 = new BufferedImage(203, 321,BufferedImage.TYPE_INT_RGB);
			g3 = (Graphics2D)bi1.getGraphics();
			paintCardsInHand(g3,g1.getPlayers()[2]);		
			g2.drawImage(bi1, 280, 270, this);		
			
			//player 3
			bi1 = new BufferedImage(321, 203,BufferedImage.TYPE_INT_RGB);
			g3 = (Graphics2D)bi1.getGraphics();
			g3.translate(0, 203);
			g3.rotate(Math.PI / -2);		
			paintCardsInHand(g3,g1.getPlayers()[1]);		
			g2.drawImage(bi1, 400, 150, this);		
	
			//player 4
			bi1 = new BufferedImage(203, 321,BufferedImage.TYPE_INT_RGB);
			g3 = (Graphics2D)bi1.getGraphics();
			g3.translate(203, 321);
			g3.rotate(Math.PI);		
			paintCardsInHand(g3,g1.getPlayers()[0]);		
			g2.drawImage(bi1, 280, 10, this);	
		}
		
		Graphics2D g5 = (Graphics2D)g;			
		g5.drawImage(contentImage,0,0,this);
	}
}
