import java.util.*;

public class Player {

	final static int MAXNUMCARDS=4;
	//protected Card[] cards = new Card[MAXNUMCARDS];
	Vector cards = new Vector(4);
	protected int points=0, curnumcards=0;
	protected String name;
	protected Vector playedCards = new Vector(4);
	
	public Player(String name)
	{
		this.name = name;
	}
	
	public void reset()
	{
		curnumcards=0;
		cards.clear();
		playedCards.clear();
	}
	
	public Vector getPlayerCards()
	{
		return playedCards;
	}
	
	public Vector getCards()
	{
		return cards;
	}
	
	public void giveCard(Card card)
	{
		if (curnumcards < MAXNUMCARDS)
		{
			cards.add(card);
			curnumcards++;
		}
		else
			System.err.println("ERROR: Player "+name+" can't hold more than "+MAXNUMCARDS+" cards!");
	}
	
	public Card drawCard(String newOwner)
	{
		// Simply play a random card.
		//System.out.println(name+" Got "+curnumcards+" cards");
		//Card card = cards[curnumcards-1];
		Card card = (Card) cards.get(curnumcards-1);
		cards.remove(curnumcards-1);
		curnumcards--;
		card.setOwner(newOwner);
		return card;
	}
	
	protected int whichSuit(Card[] totalgame, int currindex, int round, int roundplayer)
	{
		// If i'm the first player of the round, i can determine the suit!
		if ( roundplayer == 0)
			return -1;
		
		//		 retrieve the suit that we have to play, if we have it.
		int suit = totalgame[currindex-roundplayer].getSuit();
	    //System.out.println("We have to play suit "+suit);
		
		return suit;
	}
	
	protected Vector possibleCards(int suit)
	{
		Vector possiblecards = new Vector(4);
		for (int i=0; i < curnumcards; i++)
		{
			if (((Card) cards.get(i)).getSuit() == suit)
				possiblecards.addElement(cards.get(i));
		}
		
		return possiblecards;
	}
	
	protected Vector possibleWinCards(int suit)
	{
		// If we can decide the suit, all cards are possible to win with.
		Vector possiblecards;
		if (suit != -1 )
			possiblecards = possibleCards(suit);
		else
			return cards;
		
		Vector wincards = new Vector(4);
		for (int i=0; i<possiblecards.size(); i++)
			if (((Card) possiblecards.get(i)).getValue() > Game.highestcard.getValue())
				wincards.add(possiblecards.get(i));	// We can win the round with every card which has a higher value than the current winning card
		
		return wincards;
	}
	
	protected Card getHighestCard(Vector cards)
	{
		Card card;
		int highestscore = -1, highestindex=-1;
		for (int i=0; i<cards.size(); i++)
			if (((Card) cards.get(i)).getValue() > highestscore)
			{
				highestscore = ((Card) cards.get(i)).getValue();
				highestindex = i;
			}
		card = (Card) cards.get(highestindex);
		return card;
	}
	
	protected Card getLowestCard(Vector cards)
	{
		Card card;
		int lowestscore = 100, lowestindex=-1;
		for (int i=0; i<cards.size(); i++)
			if (((Card) cards.get(i)).getValue() < lowestscore)
			{
				lowestscore = ((Card) cards.get(i)).getValue();
				lowestindex = i;
			}
			
		card = (Card) cards.get(lowestindex);
		return card;
	}
	
	public Card drawCard(String newOwner,  Card[] totalgame, int currindex, int round, int roundplayer)
	{
		int suit = whichSuit(totalgame,currindex,round,roundplayer);
		Vector possiblecards=possibleCards(suit);
		Card card;
		if (possiblecards.isEmpty())
		{
			// We can play whatever we want.
			int index = Game.generator.nextInt(curnumcards);
			card = (Card) cards.get(index);
			cards.remove(index);
		}
		else
		{
			// Play one of the possible cards.
			int index = Game.generator.nextInt(possiblecards.size());
			card = (Card) possiblecards.get(index);
			cards.remove(cards.indexOf(possiblecards.get(index)));
		}
		
		//Card card = cards[curnumcards-1];
		curnumcards--;
		card.setOwner(newOwner);
		playedCards.add(card);
		//cards.remove(cards.indexOf(card));
		return card;
	}
	
	public String getName()
	{
		return name;
	}
	
	public int getPoints()
	{
		return points;
	}
	
	public void addpoints(int points)
	{
		this.points+=points;
	}
	
	public void resetPoints()
	{
		this.points=0;
	}
	
}
